' Sparrow-Schachuhr
'
' nach Reset/Wakeup:
' ohne Taste=5+5min -> beide Led leuchten
' S1=30+30min -> grm leuchtet
' S2=120+120min -> rot leuchtet
'
' warten auf Spielbeginn:
' S1= die rote Uhr luft (blinkt) und die grne Uhr wird angehalten
' S2= die grne Uhr luft (blinkt) und die rote Uhr wird angehalten
'
' wird die Bedenkzeit berschritten, leuchtet die rote/grne Uhr fr 30s dauernd
' um danach in Powerdown zu wechseln.
'-------------------------------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 16                                  '8
$swstack = 16                                  '4
$framesize = 16                                '4

Stop Watchdog : Stop Ac : Stop Adc             'Sprit sparen
Green Alias Portb.1 : Red Alias Portb.3
S1 Alias Pinb.0 : S2 Alias Pinb.2

Mcucr = &B00110010                             'sleep enable, powerdown enable, pin falling enable
Pcmsk = &B00000101                             'fr PCINT0+PCINT2
Gimsk = &B00100000                             'PCIE

Config Timer0 = Timer , Prescale = 1 :         '1,2MHz/256/1 ~4687,5Hz
On Ovf0 Tim0_isr : Enable Timer0 : Enable Interrupts : Start Timer0

Const 1sekunde = 4687
Const 5min = 300                               'Blitzschach max.300s+300s
Const 30min = 1800                             '1800s
Const 120min = 7200                            'normal Schach 7200s

Dim Delayms As Word
Dim Uhr1 As Word
Dim Uhr1max As Word
Dim Uhr2 As Word
Dim Uhr2max As Word
Dim Spieler As Byte

Init:
   Ddrb = &B01010 : Portb = &B00101            'aux, red, S2, green, S1 : pullup

   Spieler = 0
   Uhr1 = 0
   Uhr2 = 0
   Wait 1                                      'eine von 3 Zeiten whlen

   If S1 = 0 Then
      Green = 1
      Uhr1max = 30min
      Uhr2max = 30min
   Else
      If S2 = 0 Then
         Red = 1                               'Normal-Schach
         Uhr1max = 120min
         Uhr2max = 120min
      Else
         Green = 1 : Red = 1                   'Blitzschach
         Uhr1max = 5min
         Uhr2max = 5min
      End If
   End If
   Do : Loop Until S1 = S2                     'warte auf Taste losgelassen
   Waitms 199                                  'entprellen
   Do : Loop Until S1 <> S2                    'warte auf Taste Spielbegin
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Begin:
   If S1 = 0 Then                              'grn stop, rot start
      Green = 0 : Red = 1
      Spieler = 2
      Delayms = 0
   End If

   If S2 = 0 Then                              'rot stop, grn start
      Red = 0 : Green = 1
      Spieler = 1
      Delayms = 0
   End If

   Do : Loop Until S1 = S2                     'warte auf Taste losgelassen

   If Spieler = 1 Then
      If Delayms > 1sekunde Then
         Delayms = 0
         Incr Uhr1
         Toggle Green                          'Uhr luft
      End If
      If Uhr1 > Uhr1max Then
         Green = 1                             'verloren
         Goto Schlafein
      End If
   End If

   If Spieler = 2 Then
      If Delayms > 1sekunde Then
         Delayms = 0
         Incr Uhr2
         Toggle Red                            'Uhr luft
      End If
      If Uhr2 > Uhr2max Then
         Red = 1                               'verloren
         Goto Schlafein
      End If
   End If
   Goto Begin
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Schlafein:
   Delayms = 0 : Do : Loop Until Delayms > 65534       '~15s
   Delayms = 0 : Do : Loop Until Delayms > 65534       '~15s

   Portb = 5                                   'pullup fr S1+S2
   Ddrb = 0 :                                  'Licht aus
   sleep                                       'ab ins Bett
   nop                                         'wach geworden ?
Goto Init
'-------------------------------------------------------------------------------
Tim0_isr:
   Incr Delayms
Return
'-------------------------------------------------------------------------------